'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIn = require('./structure/plain/getIn');

var _getIn2 = _interopRequireDefault(_getIn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getErrorKeys = function getErrorKeys(name, type) {
  switch (type) {
    case 'Field':
      return [name, name + '._error'];
    case 'FieldArray':
      return [name + '._error'];
  }
};

var createHasError = function createHasError(_ref) {
  var getIn = _ref.getIn;

  var hasError = function hasError(field, syncErrors, asyncErrors, submitErrors) {
    var name = getIn(field, 'name');
    var type = getIn(field, 'type');
    if (!syncErrors && !asyncErrors && !submitErrors) {
      return false;
    }
    var errorKeys = getErrorKeys(name, type);

    var syncError = errorKeys.reduce(function (error, errorKey) {
      var curError = (0, _getIn2.default)(syncErrors, errorKey);
      return curError ? error + curError : error;
    }, null);
    if (syncError != null) {
      return true;
    }
    var asyncError = errorKeys.reduce(function (error, errorKey) {
      var curError = getIn(asyncErrors, errorKey);
      return curError ? error + curError : error;
    }, null);
    if (asyncError != null) {
      return true;
    }
    var submitError = errorKeys.reduce(function (error, errorKey) {
      var curError = getIn(submitErrors, errorKey);
      return curError ? error + curError : error;
    }, null);
    if (submitError != null) {
      return true;
    }

    return false;
  };
  return hasError;
};

exports.default = createHasError;