'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _hasErrors = require('../hasErrors');

var _hasErrors2 = _interopRequireDefault(_hasErrors);

var _hasError = require('../hasError');

var _hasError2 = _interopRequireDefault(_hasError);

var _plain = require('../structure/plain');

var _plain2 = _interopRequireDefault(_plain);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var plainHasErrors = (0, _hasErrors2.default)(_plain2.default);

var createIsValid = function createIsValid(structure) {
  var getIn = structure.getIn;

  var hasErrors = (0, _hasErrors2.default)(structure);
  var hasError = (0, _hasError2.default)(structure);
  return function (form) {
    var getFormState = arguments.length <= 1 || arguments[1] === undefined ? function (state) {
      return getIn(state, 'form');
    } : arguments[1];
    return function (state) {
      var formState = getFormState(state);
      var asyncErrors = getIn(formState, form + '.asyncErrors');
      var submitErrors = getIn(formState, form + '.submitErrors');
      var syncErrors = getIn(formState, form + '.syncErrors');
      var hasSyncErrors = plainHasErrors(syncErrors);
      var hasAsyncErrors = hasErrors(asyncErrors);
      var hasSubmitErrors = hasErrors(submitErrors);
      var registeredFields = getIn(formState, form + '.registeredFields') || [];
      var hasFieldWithError = registeredFields && registeredFields.some(function (field) {
        return hasError(field, syncErrors, asyncErrors, submitErrors);
      });
      return !hasSyncErrors && !hasAsyncErrors && !hasSubmitErrors && !hasFieldWithError;
    };
  };
};

exports.default = createIsValid;